/*
	ESPIx_bt.h ESPI for boot mode

			2015.7.17 M.Utsumi@ARCDEVICE
*/

#ifndef ESPI_BT_H
#define ESPI_BT_H

#include "CM01_bt.h"

#define SPI_TX	1
#define SPI_RX	0

#define ESPI_NORMAL  			0
#define ESPI_TX_TIMEOUT  		1
#define ESPI_RX_TIMEOUT  		2
#define ESPI_DATA_ERROR 		3
#define ESPI_OVERFLOW 			4
#define ESPI_SCK_HUNGUP			5
#define ESPI_CS_HUNGUP			6

extern volatile BYTE ESPI1_bStatus; 
//extern volatile WORD ESPI1_wTimeout;
//extern volatile WORD ESPI1_wTimeoutCount;

void ESPI1_Open( void );
void ESPI1_Close( void );
//void ESPI1_SetTimeout( WORD wTimeout_ms );
BOOL ESPI1_ReadEnable( void );
void ESPI1_ReadDisable( void );
BOOL ESPI1_Read( WORD* pwBuffer, WORD wSize );
BOOL ESPI1_IDReceiveEnable( void );
void ESPI1_IDReceiveDisable( void );
BOOL ESPI1_SetCommand( BYTE bId, BYTE bCommand );
void ESPI1_WriteEnable( void );
void ESPI1_WriteDisable( void );
BOOL ESPI1_Write( WORD* pwBuffer, WORD wSize );

#define ESPI1_SetCS( void ) TRIS_CS = 0
#define ESPI1_ClearCS( void ) TRIS_CS = 1
#define ESPI1_DataReady()	SPI1STATbits.SPIRBF

#endif
